=== debian/changelog ===
webkit2gtk (2.18.6-1~deb9u1) stretch; urgency=medium

  * Team upload.
  * New security and bugfix release backported from Buster.

 -- Jeremy Bicha <jbicha@debian.org>  Mon, 29 Jan 2018 20:54:00 -0500

webkit2gtk (2.18.6-1) unstable; urgency=high

  * New upstream release.
    + This fixes CVE-2018-4088, CVE-2017-13885, CVE-2017-7165,
      CVE-2017-13884, CVE-2017-7160, CVE-2017-7153, CVE-2017-7153,
      CVE-2017-7161 and CVE-2018-4096.

 -- Alberto Garcia <berto@igalia.com>  Wed, 24 Jan 2018 13:30:06 +0200

webkit2gtk (2.18.5-1) unstable; urgency=high

  * New upstream release.
    + This includes fixes to mitigate the effects of the Spectre
      vulnerability (CVE-2017-5753 and CVE-2017-5715).

 -- Alberto Garcia <berto@igalia.com>  Wed, 10 Jan 2018 14:23:33 +0200

webkit2gtk (2.18.4-1) unstable; urgency=high

  [ Alberto Garcia ]
  * New upstream release.
    + This fixes CVE-2017-13866, CVE-2017-13870, CVE-2017-7156 and
      CVE-2017-13856.
  * Refresh all patches.
  * debian/control:
    + Request native version of the Ruby package (thanks, Helmut Grohne)
      (Closes: #881637).
  * Instead of passing -DUSE_GSTREAMER_GL=OFF explicitly, let CMake do it
    if libgstreamer-plugins-bad1.0-dev is not installed.
    + debian/patches/detect-gstreamer-gl.patch:
      - Disable USE_GSTREAMER_GL if GStreamerGL is not found.
    + debian/rules:
      - Remove the list of architectures that are not using GStreamerGL.
  * debian/control:
    + Don't require libgstreamer-plugins-bad1.0-dev in hppa, m68k,
      powerpcspe, sh4 or x32.

  [ Jeremy Bicha ]
  * debian/control: Update Vcs-Git to point to correct branch.
  * Allow setting the distributor name in the User Agent string. Ubuntu
    wants this patch, but since it makes it easier to identify the user
    let's leave it disabled in Debian (Closes: #883712).
    + debian/patches/user-agent-branding.patch:
      - Patch to support updating the User-Agent string.
    + debian/rules:
      - Pass -DUSER_AGENT_GTK_DISTRIBUTOR_NAME when building for Ubuntu.

 -- Alberto Garcia <berto@igalia.com>  Tue, 19 Dec 2017 18:31:33 +0200

webkit2gtk (2.18.3-1) unstable; urgency=high

  * New upstream release.
  * The WebKitGTK+ security advisory WSA-2017-0009 lists the following
    security fixes in the latest versions of WebKitGTK+:
    + CVE-2017-13783, CVE-2017-13784, CVE-2017-13785, CVE-2017-13791,
      CVE-2017-13792, CVE-2017-13793, CVE-2017-13794, CVE-2017-13795,
      CVE-2017-13796 and CVE-2017-13802 (fixed in 2.18.1).
    + CVE-2017-13788, CVE-2017-13798, CVE-2017-13803 (fixed in 2.18.3)
  * Several cross-compilation fixes in debian/rules (thanks, Helmut
    Grohne) (Closes: #881341):
    + Include /usr/share/dpkg/architecture.mk instead of calling
      dpkg-architecture manually to set the DEB_*_ARCH variables.
    + Use DEB_BUILD_ARCH_BITS to decide whether to pass --no-keep-memory
      to the linker.
    + Use DEB_HOST_ARCH to decide whether to use -g1, -DENABLE_JIT=OFF and
      -DUSE_GSTREAMER_GL=OFF.
    + Remove the --no-relax flag for alpha, this was a workaround for a 10
      year old binutils bug.

 -- Alberto Garcia <berto@igalia.com>  Sat, 11 Nov 2017 14:26:11 +0200

webkit2gtk (2.16.6-0+deb9u1) stretch; urgency=medium

  * Team upload.
  * New upstream security and bugfix release.
  * Fixes these security issues reported in WSA-2017-0005 and
    WSA-2017-0006:
    + CVE-2017-2538, CVE-2017-7052 (fixed in 2.16.4)
    + CVE-2017-7018, CVE-2017-7030, CVE-2017-7034, CVE-2017-7037,
      CVE-2017-7039, CVE-2017-7046, CVE-2017-7048, CVE-2017-7055,
      CVE-2017-7056, CVE-2017-7061, CVE-2017-7064 (fixed in 2.16.6).
  * Add debian/patches/fix-ftbfs-m68k.patch:
    + Fix FTBFS in m68k (Closes: #868126).

 -- Jeremy Bicha <jbicha@ubuntu.com>  Mon, 07 Aug 2017 00:35:25 -0400
